HDU 5603 the soldier of love 离线+树状数组

这是bestcorder 67 div1 的1003 当时不会做 看了赛后官方题解,然后翻译了一下就过了,而且速度很快,膜拜官方题解。。

附上官方题解:

the soldier of love

我们注意到我们求的是每一组至少覆盖一个点的线段数量。

那么我们可以先求一个点都没有覆盖的的线段数量,在用nn减去即可。

我们把所有点和线段先这样离线处理:

对于每个线段,在他的右端点处记上一个左端点的标记。

对于每组点,在除了第一个点之外的其他点上,记上一个前一个点的标记,同时记录下这个点的编号。

然后从1到10^6扫一遍数轴,对每个点处理所有标记,先处理点的。

对于每一个点,找到他的前一个点,把树状数组中[p_{now} - 1, p_{pre} + 1][p?now??−1,p?pre??+1]中的和累积到这个点的编号的答案里面。

然而这个树状数组是记录什么的呢,对于每个点,找到他的线段标记,也就是这个线段的左端点,把左端点的位置在树状数组里面累加。

也就是说,对当前这个位置,树状数组记录的都是右端点在当前点左边的所有线段的左端点的累加和。 就这样O((n+m_sum)log10^{6})O((n+m?s??um)log10?6??)的时间复杂度解决。

注:还有一点题解的做法,你记录3e5的点的数组需要开二倍,这一点很重要,我觉得好恶心,因为数组开小了,交到杭电,返回T,让我一度对官方题解产生了怀疑

#include<cstdio>
#include<cstring>
#include<algorithm>
#include<iostream>
#include<cstdlib>
#include<cmath>
#include<cstdlib>
#include<vector>
#include<queue>
using namespace std;
typedef long long LL;
const int INF=0x3f3f3f3f;
const int maxn=1000000+5;
const int maxm=300000+5;
struct Point
{
    int x,pre,bel;
    bool operator<(const Point &e)const
    {
        return x<e.x;
    }
} o[maxm*2];
struct Seg
{
    int l,r;
    bool operator<(const Seg &e)const
    {
        return r<e.r;
    }
} e[maxm];
int c[maxn];
int lowbit(int x)
{
    return x&(-x);
}
void add(int i)
{
    while(i<maxn)
    {
        ++c[i];
        i+=lowbit(i);
    }
}
int query(int i)
{
    int sum=0;
    while(i>0)
    {
        sum+=c[i];
        i-=lowbit(i);
    }
    return sum;
}
int ans[maxm];
int main()
{
    int n,m;
    while(~scanf("%d%d",&n,&m))
    {
        memset(c,0,sizeof(c));
        memset(ans,0,sizeof(ans));
        for(int i=1; i<=n; ++i)
            scanf("%d%d",&e[i].l,&e[i].r);
        int cnt=0;
        for(int i=1; i<=m; ++i)
        {
            int k;
            scanf("%d",&k);
            for(int j=0; j<k; ++j)
            {
                scanf("%d",&o[++cnt].x);
                o[cnt].bel=i,o[cnt].pre=-1;
                if(j==0)continue;
                o[cnt].pre=o[cnt-1].x;
            }
            o[++cnt].x=1e6+1;
            o[cnt].bel=i,o[cnt].pre=o[cnt-1].x;;
        }
        sort(e+1,e+1+n);
        sort(o+1,o+1+cnt);
        int now=1;
        for(int i=1; i<=cnt; ++i)
        {
            while(now<=n&&e[now].r<o[i].x)
            {
                add(e[now].l);
                now++;
            }
            ans[o[i].bel]+=query(o[i].x-1)-query(o[i].pre);;
        }
        for(int i=1;i<=m;++i)
         printf("%d\n",n-ans[i]);
    }
    return 0;
}

时间: 2024-11-05 14:47:58

HDU 5603 the soldier of love 离线+树状数组的相关文章

HDU 5869 Different GCD Subarray Query 离线+树状数组

Different GCD Subarray Query Problem Description This is a simple problem. The teacher gives Bob a list of problems about GCD (Greatest Common Divisor). After studying some of them, Bob thinks that GCD is so interesting. One day, he comes up with a n

HDU 5156 - Harry and Christmas tree (dfs序+离线树状数组)

http://acm.hdu.edu.cn/showproblem.php?pid=5156 BC#25的C题. 题意是:给出一颗大小为n的树,以1为根,然后给出m次染色,每次将节点u加上一种颜色(一个节点可以有多个颜色). 最后查询树上每个节点对应子树上包含的不同颜色数量. 当时这场比赛没有做,回来看一下题目,没看标解就试着敲了一遍,于是解题思路从一开始就走上了不归路. 标解是O(n+m)的方法,主要思路是将问题转为:一次染色表示将u到根节点的路径都染上这种颜色. 但这样做需要去重,因为如果u

hdu 4605 Magic Ball Game (在线主席树/离线树状数组)

hdu 4605 题意: 有一颗树,根节点为1,每一个节点要么有两个子节点,要么没有,每个节点都有一个权值wi .然后,有一个球,附带值x . 球到达某个节点上,如果x==wi,那么球停在这个节点上 .当然,这个点是叶子节点也会停止 . 如果x<wi,那么有1/2的概率走向左子树,有1/2的概率走向右子树 . 如果x>wi,那么有1/8的概率走向左子树,有7/8的概率走向右子树 . 问球经过v节点的概率 .(停在v节点也算) 解法: 在线的话每一个节点建一棵根节点到该节点的线段树,离线的话就先

区间的关系的计数 HDU 4638 离线+树状数组

题目大意:给你n个人,每个人都有一个id,有m个询问,每次询问一个区间[l,r],问该区间内部有多少的id是连续的(单独的也算是一个) 思路:做了那么多离线+树状数组的题目,感觉这种东西就是一个模板了,23333,反正都是定义右区间的. 这题的关键难度就是如何定义id是连续的呢.我们每次往区间里面放一个数值以后都要add(pos, 1),就是把pos~n的所有的关系都+1.然后如果说在pos之前就出现id-1,就要add(pos[id-1], -1)(同理id+1也是这样),这样子表示从pos[

hdu 4417 Super Mario(离线树状数组|划分树)

Super Mario Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 2584    Accepted Submission(s): 1252 Problem Description Mario is world-famous plumber. His "burly" figure and amazing jumping a

13年山东省赛 Boring Counting(离线树状数组or主席树+二分or划分树+二分)

转载请注明出处: http://www.cnblogs.com/fraud/          ——by fraud 2224: Boring Counting Time Limit: 3 Sec  Memory Limit: 128 MB Description In this problem you are given a number sequence P consisting of N integer and Pi is the ith element in the sequence.

SPOJ DQUERY D-query 离线+树状数组

本来是想找个主席树的题目来练一下的,这个题目虽说可以用主席树做,但是用这个方法感觉更加叼炸天 第一次做这种离线方法,所谓离线,就在把所有询问先存贮起来,预处理之后再一个一个操作 像这个题目,每个操作要求区间不同元素的个数,我盲目去查的话,某个元素在之前如果出现了,我把他算在当前区间也不好,算在之前的区间也不好,都会出错. 一个好的方法就是把区间排好序,针对某个区间在树状数组上更新以及查询相应值,这样能准确查出结果,但又不影响之后的查询 具体来说,先把区间按右端点进行排序(我一开始按左端点排,想错

TOJ 4105 Lines Counting(离线树状数组)

4105.   Lines Counting Time Limit: 2.0 Seconds   Memory Limit: 150000K Total Runs: 152   Accepted Runs: 47 On the number axis, there are N lines. The two endpoints L and R of each line are integer. Give you M queries, each query contains two interval

Codeforces 220B - Little Elephant and Array 离线树状数组

This problem can be solve in simpler O(NsqrtN) solution, but I will describe O(NlogN) one. We will solve this problem in offline. For each x (0?≤?x?<?n) we should keep all the queries that end in x. Iterate that x from 0 to n?-?1. Also we need to kee